> For the complete documentation index, see [llms.txt](https://docs.rigoblock.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rigoblock.com/readme-2/protocol/extensions/amulticall/amulticall-docs.md).

# aMulticall docs

## AMulticall

As per <https://github.com/Uniswap/swap-router-contracts/blob/main/contracts/base/MulticallExtended.sol>

### checkDeadline

```solidity
modifier checkDeadline(uint256 deadline)
```

### checkPreviousBlockhash

```solidity
modifier checkPreviousBlockhash(bytes32 previousBlockhash)
```

### multicall

```solidity
function multicall(bytes[] data) public returns (bytes[] results)
```

Enables calling multiple methods in a single call to the contract

#### Parameters

| Name | Type     | Description             |
| ---- | -------- | ----------------------- |
| data | bytes\[] | Array of encoded calls. |

#### Return Values

| Name    | Type     | Description              |
| ------- | -------- | ------------------------ |
| results | bytes\[] | Array of call responses. |

### multicall

```solidity
function multicall(uint256 deadline, bytes[] data) external payable returns (bytes[])
```

Call multiple functions in the current contract and return the data from all of them if they all succeed

*The `msg.value` should not be trusted for any method callable from multicall.*

#### Parameters

| Name     | Type     | Description                                                              |
| -------- | -------- | ------------------------------------------------------------------------ |
| deadline | uint256  | The time by which this function must be called before failing            |
| data     | bytes\[] | The encoded function data for each of the calls to make to this contract |

#### Return Values

| Name | Type     | Description |
| ---- | -------- | ----------- |
| \[0] | bytes\[] |             |

### multicall

```solidity
function multicall(bytes32 previousBlockhash, bytes[] data) external payable returns (bytes[])
```

Call multiple functions in the current contract and return the data from all of them if they all succeed

*The `msg.value` should not be trusted for any method callable from multicall.*

#### Parameters

| Name              | Type     | Description                                                              |
| ----------------- | -------- | ------------------------------------------------------------------------ |
| previousBlockhash | bytes32  | The expected parent blockHash                                            |
| data              | bytes\[] | The encoded function data for each of the calls to make to this contract |

#### Return Values

| Name | Type     | Description |
| ---- | -------- | ----------- |
| \[0] | bytes\[] |             |

### \_blockTimestamp

```solidity
function _blockTimestamp() internal view virtual returns (uint256)
```

*Method that exists purely to be overridden for tests*

#### Return Values

| Name | Type    | Description                 |
| ---- | ------- | --------------------------- |
| \[0] | uint256 | The current block timestamp |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rigoblock.com/readme-2/protocol/extensions/amulticall/amulticall-docs.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
